#include "ScoreS1S.h"
#include "ScoreS2Q.h"
#include "ScoreS4S.h"
#include "ScoreSAS.h"
#include "ScoreZ2.h"
#include "ScoreA1.h"
#include "ScoreA2Q.h"
#include "ScoreHQ.h"
#include "ScoreSUM.h"
#include "ScoreQSUM.h"
#include "ScoreADMGC.h"
#include "ScoreSASGC.h"
#include "IOHandler.h"



using namespace std;

int main(int argc, char **argv)  {

  if ( argc != 3 )  {
    cout << "usage:  mixscore <score-name> <parameter-file>" << endl;
    return 1;
  }

  try  {
    string scorename = argv[1];
    if ( !scorename.compare("SNP2") )  {
      //ScoreS1S S(argv[2]);
      //S.evaluate();
    }
    else if ( !scorename.compare("QSNP1") )  {
      ScoreS2Q S(argv[2]);
      S.evaluate();
    }
    else if ( !scorename.compare("SNP1") )  {
      ScoreS4S S(argv[2]);
      S.evaluate();
    }
    else if ( !scorename.compare("MIX") )  {
      IOHandler h;
      if ( h.previewParams(argv[2]) ) {
        ScoreSASGC S(argv[2]);
        S.evaluate();
      }
      else  {
        ScoreSAS S(argv[2]);
        S.evaluate();
      }
    }
    else if ( !scorename.compare("ATT") )  {
      ScoreZ2 S(argv[2]);
      S.evaluate();
    }
    else if ( !scorename.compare("ADM") )  {
      IOHandler h;
      if ( h.previewParams(argv[2]) ) {
        ScoreADMGC S(argv[2]);
        S.evaluate();
      }
      else  {
        ScoreA1 S(argv[2]);
        S.evaluate();
      }
    }
    else if ( !scorename.compare("QATT") )  {
      ScoreZ2 S(argv[2]);
      S.scoreIsQ();
      S.evaluate();
    }
    else if ( !scorename.compare("QADM") )  {
      ScoreA2Q S(argv[2]);
      S.evaluate();
    }
    else if ( !scorename.compare("QHET") )  {
      ScoreHQ S(argv[2]);
      S.evaluate();
    }
    else if ( !scorename.compare("SUM") )  {
      ScoreSUM S(argv[2]);   // handle useempiricalvariance internally
      S.evaluate();
    }
    else if ( !scorename.compare("QSUM") )  {
      ScoreQSUM S(argv[2]);
      S.evaluate();
    }
    else  {
      cout << "unrecognized score name " << scorename << endl;
      return 1;
    }
  }
  catch ( Exception& e )  {
    cout << e.getMessage() << endl;
  }

  return 0;

}
