#ifndef _SCOREA1_
#define _SCOREA1_

#include <iostream>
#include <fstream>
#include <cmath>

#include "Exception.h"
#include "IOHandler.h"

using namespace std;


class ScoreSUM;

class ScoreA1  {

  public:

    friend class ScoreSUM;

    // constructor
    ScoreA1(char *paramfile);

    // destructor
    ~ScoreA1(void);

    // main loop
    int evaluate(void);


  private:

    // constructors for ScoreSUM
    ScoreA1(int n, int *p, int *a, double *t);
    int do_not_deallocate;


    int nsamples;
    int nsnps;

    ifstream genoStream;        // unused for now:  only for computing odds ratio
    ifstream phenoStream;
    ifstream localAncStream;
    ofstream outputStream;
    ofstream oddsratioStream;

    int *dipGenoVec;            // unused for now:  only for computing odds ratio
    int *dipPhenoVec;
    int *dipLocalAnc;
    double *globalAnc;

    // Note:  oddsratios require genotype and integral ancestry.
    string oddsratio1, oddsratio2;
    void setOddsRatios(double radmix);

    IOHandler ioh;

    double evalA1();

    int *AS;
    double *TS;

    int ncase;
    double nae, nee;

    void initializeDip(void);
    void finalizeDip(void);

    double f(double r);
    double df(double r);
    double ddf(double r);
    double find_initial_rval(void);
    double findroot(double, int *);

};

#endif
