#ifndef _SCOREA2_
#define _SCOREA2_

#include <iostream>
#include <fstream>
#include <string>
#include <cmath>

#include "IOHandler.h"
#include "Exception.h"

using namespace std;
 
class ScoreQSUM;

class ScoreA2Q  {
 
  public:

    friend class ScoreQSUM;

    // constructor
    ScoreA2Q(char *parfile);

    // destructor
    ~ScoreA2Q();

    // main loop
    int evaluate(void);

  private:

    // constructors for ScoreQSUM
    ScoreA2Q(int n, double *p, int *a, double *t);
    ScoreA2Q(int n, double *p, double *a0, double *a1, double *a2, double *t);
    bool do_not_deallocate;

    int nsamples;
    int nsnps;

    ifstream phenoStream;
    ifstream localAncStream;
    ofstream outputStream;

    double *dipPhenoVec;
    int *dipLocalAnc;
    double *globalAnc;

    IOHandler ioh;

    double evalA2Q();

};

#endif
