#ifndef _SCOREHQ_
#define _SCOREHQ_

#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cmath>

#include "IOHandler.h"
#include "Exception.h"

#include "ScoreS2Q.h"

using namespace std;

class ScoreHQ  {

  public:

    // constructor
    ScoreHQ(char *paramfile);

    // destructor
    ~ScoreHQ(void);

    // main loop
    int evaluate(void);

  private:

    int nsamples;
    int nsnps;
    int errflag;  // remove when exception handling introduced

    ifstream genoStream;
    ifstream phenoStream;
    ifstream localAncStream;

    ofstream outputStream;
    ofstream effectsizeStream;

    int    *dipGenoVec;
    double *dipPhenoVec;
    int    *dipLocalAnc;

    IOHandler ioh;

    double evalHQ();

    // data
    double XAARR, XAARV, XAAVV;
    double XAERR, XAERV, XAEVV;
    double XEERR, XEERV, XEEVV;

    string effectsize1, effectsize2;
    void setEffectSizes(double e1, double e2);

    // overloaded parameter evaluators 
    void countAll(int *G, int *A);

    // print parameters for exception message
    string errorString(void);

    inline double initpA(void);
    inline double initpE(void);

    double rootpA(double, double, double, double, double, double);
    double rootpE(double, double, double, double, double, double);
    double S(double, double, double, double, double, double, double);
    double d2S(double, double, double, double, double);

};

#endif
