#ifndef _SCORES2Q_
#define _SCORES2Q_

#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>

#include "IOHandler.h"
#include "Exception.h"

using namespace std;

class ScoreQSUM;
class ScoreHQ;

class ScoreS2Q  {

  public:

    friend class ScoreQSUM;
    friend class ScoreHQ;

    // constructor
    ScoreS2Q(char *paramfile);

    // destructor
    ~ScoreS2Q(void);

    // main loop
    int evaluate(void);

  private:

    // constructors for ScoreQSUM
    ScoreS2Q(int n, double *d, double *p, int *a);
    ScoreS2Q(int n, int *g, double *p, int *a);

    bool do_not_deallocate;
 
    int nsamples;
    int nsnps;

    bool geno_is_dosage;
    bool use_adjustment;

    ifstream genoStream;
    ifstream phenoStream;
    ifstream localAncStream;

    ofstream outputStream;
    ofstream effectsizeStream;

    int *dipGenoVec;
    int *dipLocalAnc;   

    string genoform;
    double *dipPhenoVec;
    double* genoDosages;
	
    string effectsize;
    void setEffectSize(int *baddata, double *gamma, double *phi);

    IOHandler ioh;

    double evalS2Q(void);

};

#endif
