#ifndef _SCORESUM_
#define _SCORESUM_

#include <iostream>
#include <fstream>
#include <string>

#include "IOHandler.h"
#include "Exception.h"

using namespace std;

// forward declarations
#include "ScoreS4S.h"
#include "ScoreA1.h"
#include "ScoreADMGC.h"

class ScoreSUM  {

  public:

    // constructor
    ScoreSUM(char *paramfile);

    // destructor
    ~ScoreSUM(void);

    // main loop
    int evaluate(void);

  private:

    int nsamples;
    int nsnps;
    bool geno_is_dosage;
    bool use_empirical_variance;
   
    ifstream genoStream;
    ifstream phenoStream;
    ifstream localAncStream;
    ofstream outputStream;

    int *dipGenoVec;
    int *dipPhenoVec;
    int *dipLocalAnc;

    string genoform;
    double *genoDosages;
    double *globalAnc;

    IOHandler ioh;

};


#endif
