#ifndef _SCOREZ2_
#define _SCOREZ2_

#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cmath>

#include "IOHandler.h"
#include "Exception.h"

using namespace std;

class ScoreZ2  {

  public:

    // constructor
    ScoreZ2(char *paramfile);

    // destructor
    ~ScoreZ2(void);

    // main loop
    int evaluate(void);

    // signify score was called with "QATT"
    void scoreIsQ(void);

  private:

    int nsamples;
    int nsnps;

    ifstream genoStream;
    ifstream phenoStream;
    ofstream outputStream;
    ofstream effectsizeStream;

    string genoform;
    double *dipGenoVec;
    double *dipPhenoVec;
    double *globalAnc;

    IOHandler ioh;
    double evalZ2();

    string effectsize;
    void setEffectSize(double eff);

    bool pheno_is_quantitative;
    // print parameters for exception message
    string errorString(void);

};

#endif
